require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__LINUX_NETLINK_H)) {
    eval 'sub __LINUX_NETLINK_H () {1;}' unless defined(&__LINUX_NETLINK_H);
    require 'linux/const.ph';
    require 'linux/socket.ph';
    require 'linux/types.ph';
    eval 'sub NETLINK_ROUTE () {0;}' unless defined(&NETLINK_ROUTE);
    eval 'sub NETLINK_UNUSED () {1;}' unless defined(&NETLINK_UNUSED);
    eval 'sub NETLINK_USERSOCK () {2;}' unless defined(&NETLINK_USERSOCK);
    eval 'sub NETLINK_FIREWALL () {3;}' unless defined(&NETLINK_FIREWALL);
    eval 'sub NETLINK_SOCK_DIAG () {4;}' unless defined(&NETLINK_SOCK_DIAG);
    eval 'sub NETLINK_NFLOG () {5;}' unless defined(&NETLINK_NFLOG);
    eval 'sub NETLINK_XFRM () {6;}' unless defined(&NETLINK_XFRM);
    eval 'sub NETLINK_SELINUX () {7;}' unless defined(&NETLINK_SELINUX);
    eval 'sub NETLINK_ISCSI () {8;}' unless defined(&NETLINK_ISCSI);
    eval 'sub NETLINK_AUDIT () {9;}' unless defined(&NETLINK_AUDIT);
    eval 'sub NETLINK_FIB_LOOKUP () {10;}' unless defined(&NETLINK_FIB_LOOKUP);
    eval 'sub NETLINK_CONNECTOR () {11;}' unless defined(&NETLINK_CONNECTOR);
    eval 'sub NETLINK_NETFILTER () {12;}' unless defined(&NETLINK_NETFILTER);
    eval 'sub NETLINK_IP6_FW () {13;}' unless defined(&NETLINK_IP6_FW);
    eval 'sub NETLINK_DNRTMSG () {14;}' unless defined(&NETLINK_DNRTMSG);
    eval 'sub NETLINK_KOBJECT_UEVENT () {15;}' unless defined(&NETLINK_KOBJECT_UEVENT);
    eval 'sub NETLINK_GENERIC () {16;}' unless defined(&NETLINK_GENERIC);
    eval 'sub NETLINK_SCSITRANSPORT () {18;}' unless defined(&NETLINK_SCSITRANSPORT);
    eval 'sub NETLINK_ECRYPTFS () {19;}' unless defined(&NETLINK_ECRYPTFS);
    eval 'sub NETLINK_RDMA () {20;}' unless defined(&NETLINK_RDMA);
    eval 'sub NETLINK_CRYPTO () {21;}' unless defined(&NETLINK_CRYPTO);
    eval 'sub NETLINK_SMC () {22;}' unless defined(&NETLINK_SMC);
    eval 'sub NETLINK_INET_DIAG () { &NETLINK_SOCK_DIAG;}' unless defined(&NETLINK_INET_DIAG);
    eval 'sub MAX_LINKS () {32;}' unless defined(&MAX_LINKS);
    eval 'sub NLM_F_REQUEST () {0x1;}' unless defined(&NLM_F_REQUEST);
    eval 'sub NLM_F_MULTI () {0x2;}' unless defined(&NLM_F_MULTI);
    eval 'sub NLM_F_ACK () {0x4;}' unless defined(&NLM_F_ACK);
    eval 'sub NLM_F_ECHO () {0x8;}' unless defined(&NLM_F_ECHO);
    eval 'sub NLM_F_DUMP_INTR () {0x10;}' unless defined(&NLM_F_DUMP_INTR);
    eval 'sub NLM_F_DUMP_FILTERED () {0x20;}' unless defined(&NLM_F_DUMP_FILTERED);
    eval 'sub NLM_F_ROOT () {0x100;}' unless defined(&NLM_F_ROOT);
    eval 'sub NLM_F_MATCH () {0x200;}' unless defined(&NLM_F_MATCH);
    eval 'sub NLM_F_ATOMIC () {0x400;}' unless defined(&NLM_F_ATOMIC);
    eval 'sub NLM_F_DUMP () {( &NLM_F_ROOT| &NLM_F_MATCH);}' unless defined(&NLM_F_DUMP);
    eval 'sub NLM_F_REPLACE () {0x100;}' unless defined(&NLM_F_REPLACE);
    eval 'sub NLM_F_EXCL () {0x200;}' unless defined(&NLM_F_EXCL);
    eval 'sub NLM_F_CREATE () {0x400;}' unless defined(&NLM_F_CREATE);
    eval 'sub NLM_F_APPEND () {0x800;}' unless defined(&NLM_F_APPEND);
    eval 'sub NLM_F_NONREC () {0x100;}' unless defined(&NLM_F_NONREC);
    eval 'sub NLM_F_BULK () {0x200;}' unless defined(&NLM_F_BULK);
    eval 'sub NLM_F_CAPPED () {0x100;}' unless defined(&NLM_F_CAPPED);
    eval 'sub NLM_F_ACK_TLVS () {0x200;}' unless defined(&NLM_F_ACK_TLVS);
    eval 'sub NLMSG_ALIGNTO () {4;}' unless defined(&NLMSG_ALIGNTO);
    eval 'sub NLMSG_ALIGN {
        my($len) = @_;
	    eval q(( (($len)+ &NLMSG_ALIGNTO-1) & ~( &NLMSG_ALIGNTO-1) ));
    }' unless defined(&NLMSG_ALIGN);
    eval 'sub NLMSG_HDRLEN () {(  &NLMSG_ALIGN($sizeof{\'struct nlmsghdr\'}));}' unless defined(&NLMSG_HDRLEN);
    eval 'sub NLMSG_LENGTH {
        my($len) = @_;
	    eval q((($len) +  &NLMSG_HDRLEN));
    }' unless defined(&NLMSG_LENGTH);
    eval 'sub NLMSG_SPACE {
        my($len) = @_;
	    eval q( &NLMSG_ALIGN( &NLMSG_LENGTH($len)));
    }' unless defined(&NLMSG_SPACE);
    eval 'sub NLMSG_DATA {
        my($nlh) = @_;
	    eval q((( &void *)(($nlh) +  &NLMSG_HDRLEN)));
    }' unless defined(&NLMSG_DATA);
    eval 'sub NLMSG_NEXT {
        my($nlh,$len) = @_;
	    eval q((($len) -=  &NLMSG_ALIGN(($nlh)-> &nlmsg_len), ((($nlh)) +  &NLMSG_ALIGN(($nlh)-> &nlmsg_len))));
    }' unless defined(&NLMSG_NEXT);
    eval 'sub NLMSG_OK {
        my($nlh,$len) = @_;
	    eval q(( >= $sizeof{\'struct nlmsghdr\'}  && ($nlh)-> &nlmsg_len >= $sizeof{\'struct nlmsghdr\'}  && ($nlh)-> &nlmsg_len <= ($len)));
    }' unless defined(&NLMSG_OK);
    eval 'sub NLMSG_PAYLOAD {
        my($nlh,$len) = @_;
	    eval q((($nlh)-> &nlmsg_len -  &NLMSG_SPACE(($len))));
    }' unless defined(&NLMSG_PAYLOAD);
    eval 'sub NLMSG_NOOP () {0x1;}' unless defined(&NLMSG_NOOP);
    eval 'sub NLMSG_ERROR () {0x2;}' unless defined(&NLMSG_ERROR);
    eval 'sub NLMSG_DONE () {0x3;}' unless defined(&NLMSG_DONE);
    eval 'sub NLMSG_OVERRUN () {0x4;}' unless defined(&NLMSG_OVERRUN);
    eval 'sub NLMSG_MIN_TYPE () {0x10;}' unless defined(&NLMSG_MIN_TYPE);
    eval("sub NLMSGERR_ATTR_UNUSED () { 0; }") unless defined(&NLMSGERR_ATTR_UNUSED);
    eval("sub NLMSGERR_ATTR_MSG () { 1; }") unless defined(&NLMSGERR_ATTR_MSG);
    eval("sub NLMSGERR_ATTR_OFFS () { 2; }") unless defined(&NLMSGERR_ATTR_OFFS);
    eval("sub NLMSGERR_ATTR_COOKIE () { 3; }") unless defined(&NLMSGERR_ATTR_COOKIE);
    eval("sub NLMSGERR_ATTR_POLICY () { 4; }") unless defined(&NLMSGERR_ATTR_POLICY);
    eval("sub NLMSGERR_ATTR_MISS_TYPE () { 5; }") unless defined(&NLMSGERR_ATTR_MISS_TYPE);
    eval("sub NLMSGERR_ATTR_MISS_NEST () { 6; }") unless defined(&NLMSGERR_ATTR_MISS_NEST);
    eval("sub __NLMSGERR_ATTR_MAX () { 7; }") unless defined(&__NLMSGERR_ATTR_MAX);
    eval("sub NLMSGERR_ATTR_MAX () { __NLMSGERR_ATTR_MAX-1; }") unless defined(&NLMSGERR_ATTR_MAX);
    eval 'sub NETLINK_ADD_MEMBERSHIP () {1;}' unless defined(&NETLINK_ADD_MEMBERSHIP);
    eval 'sub NETLINK_DROP_MEMBERSHIP () {2;}' unless defined(&NETLINK_DROP_MEMBERSHIP);
    eval 'sub NETLINK_PKTINFO () {3;}' unless defined(&NETLINK_PKTINFO);
    eval 'sub NETLINK_BROADCAST_ERROR () {4;}' unless defined(&NETLINK_BROADCAST_ERROR);
    eval 'sub NETLINK_NO_ENOBUFS () {5;}' unless defined(&NETLINK_NO_ENOBUFS);
    eval 'sub NETLINK_RX_RING () {6;}' unless defined(&NETLINK_RX_RING);
    eval 'sub NETLINK_TX_RING () {7;}' unless defined(&NETLINK_TX_RING);
    eval 'sub NETLINK_LISTEN_ALL_NSID () {8;}' unless defined(&NETLINK_LISTEN_ALL_NSID);
    eval 'sub NETLINK_LIST_MEMBERSHIPS () {9;}' unless defined(&NETLINK_LIST_MEMBERSHIPS);
    eval 'sub NETLINK_CAP_ACK () {10;}' unless defined(&NETLINK_CAP_ACK);
    eval 'sub NETLINK_EXT_ACK () {11;}' unless defined(&NETLINK_EXT_ACK);
    eval 'sub NETLINK_GET_STRICT_CHK () {12;}' unless defined(&NETLINK_GET_STRICT_CHK);
    eval("sub NL_MMAP_STATUS_UNUSED () { 0; }") unless defined(&NL_MMAP_STATUS_UNUSED);
    eval("sub NL_MMAP_STATUS_RESERVED () { 1; }") unless defined(&NL_MMAP_STATUS_RESERVED);
    eval("sub NL_MMAP_STATUS_VALID () { 2; }") unless defined(&NL_MMAP_STATUS_VALID);
    eval("sub NL_MMAP_STATUS_COPY () { 3; }") unless defined(&NL_MMAP_STATUS_COPY);
    eval("sub NL_MMAP_STATUS_SKIP () { 4; }") unless defined(&NL_MMAP_STATUS_SKIP);
    eval 'sub NL_MMAP_MSG_ALIGNMENT () { &NLMSG_ALIGNTO;}' unless defined(&NL_MMAP_MSG_ALIGNMENT);
    eval 'sub NL_MMAP_MSG_ALIGN {
        my($sz) = @_;
	    eval q( &__ALIGN_KERNEL($sz,  &NL_MMAP_MSG_ALIGNMENT));
    }' unless defined(&NL_MMAP_MSG_ALIGN);
    eval 'sub NL_MMAP_HDRLEN () { &NL_MMAP_MSG_ALIGN($sizeof{\'struct nl_mmap_hdr\'});}' unless defined(&NL_MMAP_HDRLEN);
    eval 'sub NET_MAJOR () {36;}' unless defined(&NET_MAJOR);
    eval("sub NETLINK_UNCONNECTED () { 0; }") unless defined(&NETLINK_UNCONNECTED);
    eval("sub NETLINK_CONNECTED () { 1; }") unless defined(&NETLINK_CONNECTED);
    eval 'sub NLA_F_NESTED () {(1<< 15);}' unless defined(&NLA_F_NESTED);
    eval 'sub NLA_F_NET_BYTEORDER () {(1<< 14);}' unless defined(&NLA_F_NET_BYTEORDER);
    eval 'sub NLA_TYPE_MASK () {~( &NLA_F_NESTED |  &NLA_F_NET_BYTEORDER);}' unless defined(&NLA_TYPE_MASK);
    eval 'sub NLA_ALIGNTO () {4;}' unless defined(&NLA_ALIGNTO);
    eval 'sub NLA_ALIGN {
        my($len) = @_;
	    eval q(((($len) +  &NLA_ALIGNTO - 1) & ~( &NLA_ALIGNTO - 1)));
    }' unless defined(&NLA_ALIGN);
    eval 'sub NLA_HDRLEN () {(  &NLA_ALIGN($sizeof{\'struct nlattr\'}));}' unless defined(&NLA_HDRLEN);
    eval("sub NL_ATTR_TYPE_INVALID () { 0; }") unless defined(&NL_ATTR_TYPE_INVALID);
    eval("sub NL_ATTR_TYPE_FLAG () { 1; }") unless defined(&NL_ATTR_TYPE_FLAG);
    eval("sub NL_ATTR_TYPE_U8 () { 2; }") unless defined(&NL_ATTR_TYPE_U8);
    eval("sub NL_ATTR_TYPE_U16 () { 3; }") unless defined(&NL_ATTR_TYPE_U16);
    eval("sub NL_ATTR_TYPE_U32 () { 4; }") unless defined(&NL_ATTR_TYPE_U32);
    eval("sub NL_ATTR_TYPE_U64 () { 5; }") unless defined(&NL_ATTR_TYPE_U64);
    eval("sub NL_ATTR_TYPE_S8 () { 6; }") unless defined(&NL_ATTR_TYPE_S8);
    eval("sub NL_ATTR_TYPE_S16 () { 7; }") unless defined(&NL_ATTR_TYPE_S16);
    eval("sub NL_ATTR_TYPE_S32 () { 8; }") unless defined(&NL_ATTR_TYPE_S32);
    eval("sub NL_ATTR_TYPE_S64 () { 9; }") unless defined(&NL_ATTR_TYPE_S64);
    eval("sub NL_ATTR_TYPE_BINARY () { 10; }") unless defined(&NL_ATTR_TYPE_BINARY);
    eval("sub NL_ATTR_TYPE_STRING () { 11; }") unless defined(&NL_ATTR_TYPE_STRING);
    eval("sub NL_ATTR_TYPE_NUL_STRING () { 12; }") unless defined(&NL_ATTR_TYPE_NUL_STRING);
    eval("sub NL_ATTR_TYPE_NESTED () { 13; }") unless defined(&NL_ATTR_TYPE_NESTED);
    eval("sub NL_ATTR_TYPE_NESTED_ARRAY () { 14; }") unless defined(&NL_ATTR_TYPE_NESTED_ARRAY);
    eval("sub NL_ATTR_TYPE_BITFIELD32 () { 15; }") unless defined(&NL_ATTR_TYPE_BITFIELD32);
    eval("sub NL_ATTR_TYPE_SINT () { 16; }") unless defined(&NL_ATTR_TYPE_SINT);
    eval("sub NL_ATTR_TYPE_UINT () { 17; }") unless defined(&NL_ATTR_TYPE_UINT);
    eval("sub NL_POLICY_TYPE_ATTR_UNSPEC () { 0; }") unless defined(&NL_POLICY_TYPE_ATTR_UNSPEC);
    eval("sub NL_POLICY_TYPE_ATTR_TYPE () { 1; }") unless defined(&NL_POLICY_TYPE_ATTR_TYPE);
    eval("sub NL_POLICY_TYPE_ATTR_MIN_VALUE_S () { 2; }") unless defined(&NL_POLICY_TYPE_ATTR_MIN_VALUE_S);
    eval("sub NL_POLICY_TYPE_ATTR_MAX_VALUE_S () { 3; }") unless defined(&NL_POLICY_TYPE_ATTR_MAX_VALUE_S);
    eval("sub NL_POLICY_TYPE_ATTR_MIN_VALUE_U () { 4; }") unless defined(&NL_POLICY_TYPE_ATTR_MIN_VALUE_U);
    eval("sub NL_POLICY_TYPE_ATTR_MAX_VALUE_U () { 5; }") unless defined(&NL_POLICY_TYPE_ATTR_MAX_VALUE_U);
    eval("sub NL_POLICY_TYPE_ATTR_MIN_LENGTH () { 6; }") unless defined(&NL_POLICY_TYPE_ATTR_MIN_LENGTH);
    eval("sub NL_POLICY_TYPE_ATTR_MAX_LENGTH () { 7; }") unless defined(&NL_POLICY_TYPE_ATTR_MAX_LENGTH);
    eval("sub NL_POLICY_TYPE_ATTR_POLICY_IDX () { 8; }") unless defined(&NL_POLICY_TYPE_ATTR_POLICY_IDX);
    eval("sub NL_POLICY_TYPE_ATTR_POLICY_MAXTYPE () { 9; }") unless defined(&NL_POLICY_TYPE_ATTR_POLICY_MAXTYPE);
    eval("sub NL_POLICY_TYPE_ATTR_BITFIELD32_MASK () { 10; }") unless defined(&NL_POLICY_TYPE_ATTR_BITFIELD32_MASK);
    eval("sub NL_POLICY_TYPE_ATTR_PAD () { 11; }") unless defined(&NL_POLICY_TYPE_ATTR_PAD);
    eval("sub NL_POLICY_TYPE_ATTR_MASK () { 12; }") unless defined(&NL_POLICY_TYPE_ATTR_MASK);
    eval("sub __NL_POLICY_TYPE_ATTR_MAX () { 13; }") unless defined(&__NL_POLICY_TYPE_ATTR_MAX);
    eval("sub NL_POLICY_TYPE_ATTR_MAX () { __NL_POLICY_TYPE_ATTR_MAX-1; }") unless defined(&NL_POLICY_TYPE_ATTR_MAX);
}
1;
