require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_STDBIT_H)) {
    eval 'sub _STDBIT_H () {1;}' unless defined(&_STDBIT_H);
    require 'features.ph';
    require 'bits/endian.ph';
    require 'bits/stdint-intn.ph';
    require 'bits/stdint-uintn.ph';
    require 'bits/stdint-least.ph';
    require 'stdbool.ph';
    eval 'sub __need_size_t () {1;}' unless defined(&__need_size_t);
    require 'stddef.ph';
    eval 'sub __STDC_VERSION_STDBIT_H__ () {202311;}' unless defined(&__STDC_VERSION_STDBIT_H__);
    eval 'sub __STDC_ENDIAN_LITTLE__ () { &__LITTLE_ENDIAN;}' unless defined(&__STDC_ENDIAN_LITTLE__);
    eval 'sub __STDC_ENDIAN_BIG__ () { &__BIG_ENDIAN;}' unless defined(&__STDC_ENDIAN_BIG__);
    eval 'sub __STDC_ENDIAN_NATIVE__ () { &__BYTE_ORDER;}' unless defined(&__STDC_ENDIAN_NATIVE__);
    if( &__GNUC_PREREQ (11, 0)) {
	eval 'sub __pacify_uint8 {
	    my($n) = @_;
    	    eval q(($n));
	}' unless defined(&__pacify_uint8);
	eval 'sub __pacify_uint16 {
	    my($n) = @_;
    	    eval q(($n));
	}' unless defined(&__pacify_uint16);
    } else {
	eval 'sub __pacify_uint8 {
	    my($n) = @_;
    	    eval q((( &uint8_t) ($n)));
	}' unless defined(&__pacify_uint8);
	eval 'sub __pacify_uint16 {
	    my($n) = @_;
    	    eval q((( &uint16_t) ($n)));
	}' unless defined(&__pacify_uint16);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_leading_zeros) ? &__builtin_stdc_leading_zeros : undef))) {
	eval 'sub stdc_leading_zeros {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_leading_zeros ($x)));
	}' unless defined(&stdc_leading_zeros);
    } else {
	eval 'sub stdc_leading_zeros {
	    my($x) = @_;
    	    eval q(( &stdc_leading_zeros_ull ($x) -  (8* ($sizeof{0} - $sizeof{$x}))));
	}' unless defined(&stdc_leading_zeros);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_clzll) ? &__builtin_clzll : undef))) {
	eval 'sub stdc_leading_zeros_uc {
	    my($x) = @_;
    	    eval q(( &__clz8_inline ($x)));
	}' unless defined(&stdc_leading_zeros_uc);
	eval 'sub stdc_leading_zeros_us {
	    my($x) = @_;
    	    eval q(( &__clz16_inline ($x)));
	}' unless defined(&stdc_leading_zeros_us);
	eval 'sub stdc_leading_zeros_ui {
	    my($x) = @_;
    	    eval q(( &__clz32_inline ($x)));
	}' unless defined(&stdc_leading_zeros_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_leading_zeros_ul {
	        my($x) = @_;
    		eval q(( &__clz64_inline ($x)));
	    }' unless defined(&stdc_leading_zeros_ul);
	} else {
	    eval 'sub stdc_leading_zeros_ul {
	        my($x) = @_;
    		eval q(( &__clz32_inline ($x)));
	    }' unless defined(&stdc_leading_zeros_ul);
	}
	eval 'sub stdc_leading_zeros_ull {
	    my($x) = @_;
    	    eval q(( &__clz64_inline ($x)));
	}' unless defined(&stdc_leading_zeros_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_leading_ones) ? &__builtin_stdc_leading_ones : undef))) {
	eval 'sub stdc_leading_ones {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_leading_ones ($x)));
	}' unless defined(&stdc_leading_ones);
    } else {
	eval 'sub stdc_leading_ones {
	    my($x) = @_;
    	    eval q(( &stdc_leading_ones_ull ( ($x) << 8* ($sizeof{0} - $sizeof{$x}))));
	}' unless defined(&stdc_leading_ones);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_clzll) ? &__builtin_clzll : undef))) {
	eval 'sub stdc_leading_ones_uc {
	    my($x) = @_;
    	    eval q(( &__clo8_inline ($x)));
	}' unless defined(&stdc_leading_ones_uc);
	eval 'sub stdc_leading_ones_us {
	    my($x) = @_;
    	    eval q(( &__clo16_inline ($x)));
	}' unless defined(&stdc_leading_ones_us);
	eval 'sub stdc_leading_ones_ui {
	    my($x) = @_;
    	    eval q(( &__clo32_inline ($x)));
	}' unless defined(&stdc_leading_ones_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_leading_ones_ul {
	        my($x) = @_;
    		eval q(( &__clo64_inline ($x)));
	    }' unless defined(&stdc_leading_ones_ul);
	} else {
	    eval 'sub stdc_leading_ones_ul {
	        my($x) = @_;
    		eval q(( &__clo32_inline ($x)));
	    }' unless defined(&stdc_leading_ones_ul);
	}
	eval 'sub stdc_leading_ones_ull {
	    my($x) = @_;
    	    eval q(( &__clo64_inline ($x)));
	}' unless defined(&stdc_leading_ones_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_trailing_zeros) ? &__builtin_stdc_trailing_zeros : undef))) {
	eval 'sub stdc_trailing_zeros {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_trailing_zeros ($x)));
	}' unless defined(&stdc_trailing_zeros);
    } else {
	eval 'sub stdc_trailing_zeros {
	    my($x) = @_;
    	    eval q(($sizeof{$x} == 8?  &stdc_trailing_zeros_ull ($x) : $sizeof{$x} == 4?  &stdc_trailing_zeros_ui ($x) : $sizeof{$x} == 2?  &stdc_trailing_zeros_us ( &__pacify_uint16 ($x)) :  &stdc_trailing_zeros_uc ( &__pacify_uint8 ($x))));
	}' unless defined(&stdc_trailing_zeros);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_ctzll) ? &__builtin_ctzll : undef))) {
	eval 'sub stdc_trailing_zeros_uc {
	    my($x) = @_;
    	    eval q(( &__ctz8_inline ($x)));
	}' unless defined(&stdc_trailing_zeros_uc);
	eval 'sub stdc_trailing_zeros_us {
	    my($x) = @_;
    	    eval q(( &__ctz16_inline ($x)));
	}' unless defined(&stdc_trailing_zeros_us);
	eval 'sub stdc_trailing_zeros_ui {
	    my($x) = @_;
    	    eval q(( &__ctz32_inline ($x)));
	}' unless defined(&stdc_trailing_zeros_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_trailing_zeros_ul {
	        my($x) = @_;
    		eval q(( &__ctz64_inline ($x)));
	    }' unless defined(&stdc_trailing_zeros_ul);
	} else {
	    eval 'sub stdc_trailing_zeros_ul {
	        my($x) = @_;
    		eval q(( &__ctz32_inline ($x)));
	    }' unless defined(&stdc_trailing_zeros_ul);
	}
	eval 'sub stdc_trailing_zeros_ull {
	    my($x) = @_;
    	    eval q(( &__ctz64_inline ($x)));
	}' unless defined(&stdc_trailing_zeros_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_trailing_ones) ? &__builtin_stdc_trailing_ones : undef))) {
	eval 'sub stdc_trailing_ones {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_trailing_ones ($x)));
	}' unless defined(&stdc_trailing_ones);
    } else {
	eval 'sub stdc_trailing_ones {
	    my($x) = @_;
    	    eval q(( &stdc_trailing_ones_ull ($x)));
	}' unless defined(&stdc_trailing_ones);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_ctzll) ? &__builtin_ctzll : undef))) {
	eval 'sub stdc_trailing_ones_uc {
	    my($x) = @_;
    	    eval q(( &__cto8_inline ($x)));
	}' unless defined(&stdc_trailing_ones_uc);
	eval 'sub stdc_trailing_ones_us {
	    my($x) = @_;
    	    eval q(( &__cto16_inline ($x)));
	}' unless defined(&stdc_trailing_ones_us);
	eval 'sub stdc_trailing_ones_ui {
	    my($x) = @_;
    	    eval q(( &__cto32_inline ($x)));
	}' unless defined(&stdc_trailing_ones_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_trailing_ones_ul {
	        my($x) = @_;
    		eval q(( &__cto64_inline ($x)));
	    }' unless defined(&stdc_trailing_ones_ul);
	} else {
	    eval 'sub stdc_trailing_ones_ul {
	        my($x) = @_;
    		eval q(( &__cto32_inline ($x)));
	    }' unless defined(&stdc_trailing_ones_ul);
	}
	eval 'sub stdc_trailing_ones_ull {
	    my($x) = @_;
    	    eval q(( &__cto64_inline ($x)));
	}' unless defined(&stdc_trailing_ones_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_first_leading_zero) ? &__builtin_stdc_first_leading_zero : undef))) {
	eval 'sub stdc_first_leading_zero {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_first_leading_zero ($x)));
	}' unless defined(&stdc_first_leading_zero);
    } else {
	eval 'sub stdc_first_leading_zero {
	    my($x) = @_;
    	    eval q(($sizeof{$x} == 8?  &stdc_first_leading_zero_ull ($x) : $sizeof{$x} == 4?  &stdc_first_leading_zero_ui ($x) : $sizeof{$x} == 2?  &stdc_first_leading_zero_us ( &__pacify_uint16 ($x)) :  &stdc_first_leading_zero_uc ( &__pacify_uint8 ($x))));
	}' unless defined(&stdc_first_leading_zero);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_clzll) ? &__builtin_clzll : undef))) {
	eval 'sub stdc_first_leading_zero_uc {
	    my($x) = @_;
    	    eval q(( &__flz8_inline ($x)));
	}' unless defined(&stdc_first_leading_zero_uc);
	eval 'sub stdc_first_leading_zero_us {
	    my($x) = @_;
    	    eval q(( &__flz16_inline ($x)));
	}' unless defined(&stdc_first_leading_zero_us);
	eval 'sub stdc_first_leading_zero_ui {
	    my($x) = @_;
    	    eval q(( &__flz32_inline ($x)));
	}' unless defined(&stdc_first_leading_zero_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_first_leading_zero_ul {
	        my($x) = @_;
    		eval q(( &__flz64_inline ($x)));
	    }' unless defined(&stdc_first_leading_zero_ul);
	} else {
	    eval 'sub stdc_first_leading_zero_ul {
	        my($x) = @_;
    		eval q(( &__flz32_inline ($x)));
	    }' unless defined(&stdc_first_leading_zero_ul);
	}
	eval 'sub stdc_first_leading_zero_ull {
	    my($x) = @_;
    	    eval q(( &__flz64_inline ($x)));
	}' unless defined(&stdc_first_leading_zero_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_first_leading_one) ? &__builtin_stdc_first_leading_one : undef))) {
	eval 'sub stdc_first_leading_one {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_first_leading_one ($x)));
	}' unless defined(&stdc_first_leading_one);
    } else {
	eval 'sub stdc_first_leading_one {
	    my($x) = @_;
    	    eval q(($sizeof{$x} == 8?  &stdc_first_leading_one_ull ($x) : $sizeof{$x} == 4?  &stdc_first_leading_one_ui ($x) : $sizeof{$x} == 2?  &stdc_first_leading_one_us ( &__pacify_uint16 ($x)) :  &stdc_first_leading_one_uc ( &__pacify_uint8 ($x))));
	}' unless defined(&stdc_first_leading_one);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_clzll) ? &__builtin_clzll : undef))) {
	eval 'sub stdc_first_leading_one_uc {
	    my($x) = @_;
    	    eval q(( &__flo8_inline ($x)));
	}' unless defined(&stdc_first_leading_one_uc);
	eval 'sub stdc_first_leading_one_us {
	    my($x) = @_;
    	    eval q(( &__flo16_inline ($x)));
	}' unless defined(&stdc_first_leading_one_us);
	eval 'sub stdc_first_leading_one_ui {
	    my($x) = @_;
    	    eval q(( &__flo32_inline ($x)));
	}' unless defined(&stdc_first_leading_one_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_first_leading_one_ul {
	        my($x) = @_;
    		eval q(( &__flo64_inline ($x)));
	    }' unless defined(&stdc_first_leading_one_ul);
	} else {
	    eval 'sub stdc_first_leading_one_ul {
	        my($x) = @_;
    		eval q(( &__flo32_inline ($x)));
	    }' unless defined(&stdc_first_leading_one_ul);
	}
	eval 'sub stdc_first_leading_one_ull {
	    my($x) = @_;
    	    eval q(( &__flo64_inline ($x)));
	}' unless defined(&stdc_first_leading_one_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_first_trailing_zero) ? &__builtin_stdc_first_trailing_zero : undef))) {
	eval 'sub stdc_first_trailing_zero {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_first_trailing_zero ($x)));
	}' unless defined(&stdc_first_trailing_zero);
    } else {
	eval 'sub stdc_first_trailing_zero {
	    my($x) = @_;
    	    eval q(($sizeof{$x} == 8?  &stdc_first_trailing_zero_ull ($x) : $sizeof{$x} == 4?  &stdc_first_trailing_zero_ui ($x) : $sizeof{$x} == 2?  &stdc_first_trailing_zero_us ( &__pacify_uint16 ($x)) :  &stdc_first_trailing_zero_uc ( &__pacify_uint8 ($x))));
	}' unless defined(&stdc_first_trailing_zero);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_ctzll) ? &__builtin_ctzll : undef))) {
	eval 'sub stdc_first_trailing_zero_uc {
	    my($x) = @_;
    	    eval q(( &__ftz8_inline ($x)));
	}' unless defined(&stdc_first_trailing_zero_uc);
	eval 'sub stdc_first_trailing_zero_us {
	    my($x) = @_;
    	    eval q(( &__ftz16_inline ($x)));
	}' unless defined(&stdc_first_trailing_zero_us);
	eval 'sub stdc_first_trailing_zero_ui {
	    my($x) = @_;
    	    eval q(( &__ftz32_inline ($x)));
	}' unless defined(&stdc_first_trailing_zero_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_first_trailing_zero_ul {
	        my($x) = @_;
    		eval q(( &__ftz64_inline ($x)));
	    }' unless defined(&stdc_first_trailing_zero_ul);
	} else {
	    eval 'sub stdc_first_trailing_zero_ul {
	        my($x) = @_;
    		eval q(( &__ftz32_inline ($x)));
	    }' unless defined(&stdc_first_trailing_zero_ul);
	}
	eval 'sub stdc_first_trailing_zero_ull {
	    my($x) = @_;
    	    eval q(( &__ftz64_inline ($x)));
	}' unless defined(&stdc_first_trailing_zero_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_first_trailing_one) ? &__builtin_stdc_first_trailing_one : undef))) {
	eval 'sub stdc_first_trailing_one {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_first_trailing_one ($x)));
	}' unless defined(&stdc_first_trailing_one);
    } else {
	eval 'sub stdc_first_trailing_one {
	    my($x) = @_;
    	    eval q(($sizeof{$x} == 8?  &stdc_first_trailing_one_ull ($x) : $sizeof{$x} == 4?  &stdc_first_trailing_one_ui ($x) : $sizeof{$x} == 2?  &stdc_first_trailing_one_us ( &__pacify_uint16 ($x)) :  &stdc_first_trailing_one_uc ( &__pacify_uint8 ($x))));
	}' unless defined(&stdc_first_trailing_one);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_ctzll) ? &__builtin_ctzll : undef))) {
	eval 'sub stdc_first_trailing_one_uc {
	    my($x) = @_;
    	    eval q(( &__fto8_inline ($x)));
	}' unless defined(&stdc_first_trailing_one_uc);
	eval 'sub stdc_first_trailing_one_us {
	    my($x) = @_;
    	    eval q(( &__fto16_inline ($x)));
	}' unless defined(&stdc_first_trailing_one_us);
	eval 'sub stdc_first_trailing_one_ui {
	    my($x) = @_;
    	    eval q(( &__fto32_inline ($x)));
	}' unless defined(&stdc_first_trailing_one_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_first_trailing_one_ul {
	        my($x) = @_;
    		eval q(( &__fto64_inline ($x)));
	    }' unless defined(&stdc_first_trailing_one_ul);
	} else {
	    eval 'sub stdc_first_trailing_one_ul {
	        my($x) = @_;
    		eval q(( &__fto32_inline ($x)));
	    }' unless defined(&stdc_first_trailing_one_ul);
	}
	eval 'sub stdc_first_trailing_one_ull {
	    my($x) = @_;
    	    eval q(( &__fto64_inline ($x)));
	}' unless defined(&stdc_first_trailing_one_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_count_zeros) ? &__builtin_stdc_count_zeros : undef))) {
	eval 'sub stdc_count_zeros {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_count_zeros ($x)));
	}' unless defined(&stdc_count_zeros);
    } else {
	eval 'sub stdc_count_zeros {
	    my($x) = @_;
    	    eval q(( &stdc_count_zeros_ull ($x) -  (8* ($sizeof{0} - $sizeof{$x}))));
	}' unless defined(&stdc_count_zeros);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_popcountll) ? &__builtin_popcountll : undef))) {
	eval 'sub stdc_count_zeros_uc {
	    my($x) = @_;
    	    eval q(( &__cz8_inline ($x)));
	}' unless defined(&stdc_count_zeros_uc);
	eval 'sub stdc_count_zeros_us {
	    my($x) = @_;
    	    eval q(( &__cz16_inline ($x)));
	}' unless defined(&stdc_count_zeros_us);
	eval 'sub stdc_count_zeros_ui {
	    my($x) = @_;
    	    eval q(( &__cz32_inline ($x)));
	}' unless defined(&stdc_count_zeros_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_count_zeros_ul {
	        my($x) = @_;
    		eval q(( &__cz64_inline ($x)));
	    }' unless defined(&stdc_count_zeros_ul);
	} else {
	    eval 'sub stdc_count_zeros_ul {
	        my($x) = @_;
    		eval q(( &__cz32_inline ($x)));
	    }' unless defined(&stdc_count_zeros_ul);
	}
	eval 'sub stdc_count_zeros_ull {
	    my($x) = @_;
    	    eval q(( &__cz64_inline ($x)));
	}' unless defined(&stdc_count_zeros_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_count_ones) ? &__builtin_stdc_count_ones : undef))) {
	eval 'sub stdc_count_ones {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_count_ones ($x)));
	}' unless defined(&stdc_count_ones);
    } else {
	eval 'sub stdc_count_ones {
	    my($x) = @_;
    	    eval q(( &stdc_count_ones_ull ($x)));
	}' unless defined(&stdc_count_ones);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_popcountll) ? &__builtin_popcountll : undef))) {
	eval 'sub stdc_count_ones_uc {
	    my($x) = @_;
    	    eval q(( &__co8_inline ($x)));
	}' unless defined(&stdc_count_ones_uc);
	eval 'sub stdc_count_ones_us {
	    my($x) = @_;
    	    eval q(( &__co16_inline ($x)));
	}' unless defined(&stdc_count_ones_us);
	eval 'sub stdc_count_ones_ui {
	    my($x) = @_;
    	    eval q(( &__co32_inline ($x)));
	}' unless defined(&stdc_count_ones_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_count_ones_ul {
	        my($x) = @_;
    		eval q(( &__co64_inline ($x)));
	    }' unless defined(&stdc_count_ones_ul);
	} else {
	    eval 'sub stdc_count_ones_ul {
	        my($x) = @_;
    		eval q(( &__co32_inline ($x)));
	    }' unless defined(&stdc_count_ones_ul);
	}
	eval 'sub stdc_count_ones_ull {
	    my($x) = @_;
    	    eval q(( &__co64_inline ($x)));
	}' unless defined(&stdc_count_ones_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_has_single_bit) ? &__builtin_stdc_has_single_bit : undef))) {
	eval 'sub stdc_has_single_bit {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_has_single_bit ($x)));
	}' unless defined(&stdc_has_single_bit);
    } else {
	eval 'sub stdc_has_single_bit {
	    my($x) = @_;
    	    eval q((( &bool) ($sizeof{$x} <= $sizeof{\'unsigned int\'} ?  &stdc_has_single_bit_ui ($x) :  &stdc_has_single_bit_ull ($x))));
	}' unless defined(&stdc_has_single_bit);
    }
    eval 'sub stdc_has_single_bit_uc {
        my($x) = @_;
	    eval q(( &__hsb8_inline ($x)));
    }' unless defined(&stdc_has_single_bit_uc);
    eval 'sub stdc_has_single_bit_us {
        my($x) = @_;
	    eval q(( &__hsb16_inline ($x)));
    }' unless defined(&stdc_has_single_bit_us);
    eval 'sub stdc_has_single_bit_ui {
        my($x) = @_;
	    eval q(( &__hsb32_inline ($x)));
    }' unless defined(&stdc_has_single_bit_ui);
    if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	eval 'sub stdc_has_single_bit_ul {
	    my($x) = @_;
    	    eval q(( &__hsb64_inline ($x)));
	}' unless defined(&stdc_has_single_bit_ul);
    } else {
	eval 'sub stdc_has_single_bit_ul {
	    my($x) = @_;
    	    eval q(( &__hsb32_inline ($x)));
	}' unless defined(&stdc_has_single_bit_ul);
    }
    eval 'sub stdc_has_single_bit_ull {
        my($x) = @_;
	    eval q(( &__hsb64_inline ($x)));
    }' unless defined(&stdc_has_single_bit_ull);
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_bit_width) ? &__builtin_stdc_bit_width : undef))) {
	eval 'sub stdc_bit_width {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_bit_width ($x)));
	}' unless defined(&stdc_bit_width);
    } else {
	eval 'sub stdc_bit_width {
	    my($x) = @_;
    	    eval q(( &stdc_bit_width_ull ($x)));
	}' unless defined(&stdc_bit_width);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_clzll) ? &__builtin_clzll : undef))) {
	eval 'sub stdc_bit_width_uc {
	    my($x) = @_;
    	    eval q(( &__bw8_inline ($x)));
	}' unless defined(&stdc_bit_width_uc);
	eval 'sub stdc_bit_width_us {
	    my($x) = @_;
    	    eval q(( &__bw16_inline ($x)));
	}' unless defined(&stdc_bit_width_us);
	eval 'sub stdc_bit_width_ui {
	    my($x) = @_;
    	    eval q(( &__bw32_inline ($x)));
	}' unless defined(&stdc_bit_width_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_bit_width_ul {
	        my($x) = @_;
    		eval q(( &__bw64_inline ($x)));
	    }' unless defined(&stdc_bit_width_ul);
	} else {
	    eval 'sub stdc_bit_width_ul {
	        my($x) = @_;
    		eval q(( &__bw32_inline ($x)));
	    }' unless defined(&stdc_bit_width_ul);
	}
	eval 'sub stdc_bit_width_ull {
	    my($x) = @_;
    	    eval q(( &__bw64_inline ($x)));
	}' unless defined(&stdc_bit_width_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_bit_floor) ? &__builtin_stdc_bit_floor : undef))) {
	eval 'sub stdc_bit_floor {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_bit_floor ($x)));
	}' unless defined(&stdc_bit_floor);
    } else {
	eval 'sub stdc_bit_floor {
	    my($x) = @_;
    	    eval q((( &__typeof ($x))  &stdc_bit_floor_ull ($x)));
	}' unless defined(&stdc_bit_floor);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_clzll) ? &__builtin_clzll : undef))) {
	eval 'sub stdc_bit_floor_uc {
	    my($x) = @_;
    	    eval q((  &__bf8_inline ($x)));
	}' unless defined(&stdc_bit_floor_uc);
	eval 'sub stdc_bit_floor_us {
	    my($x) = @_;
    	    eval q((  &__bf16_inline ($x)));
	}' unless defined(&stdc_bit_floor_us);
	eval 'sub stdc_bit_floor_ui {
	    my($x) = @_;
    	    eval q((  &__bf32_inline ($x)));
	}' unless defined(&stdc_bit_floor_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_bit_floor_ul {
	        my($x) = @_;
    		eval q((  &__bf64_inline ($x)));
	    }' unless defined(&stdc_bit_floor_ul);
	} else {
	    eval 'sub stdc_bit_floor_ul {
	        my($x) = @_;
    		eval q((  &__bf32_inline ($x)));
	    }' unless defined(&stdc_bit_floor_ul);
	}
	eval 'sub stdc_bit_floor_ull {
	    my($x) = @_;
    	    eval q((  &__bf64_inline ($x)));
	}' unless defined(&stdc_bit_floor_ull);
    }
    if( &__glibc_has_builtin ((defined(&__builtin_stdc_bit_ceil) ? &__builtin_stdc_bit_ceil : undef))) {
	eval 'sub stdc_bit_ceil {
	    my($x) = @_;
    	    eval q(( &__builtin_stdc_bit_ceil ($x)));
	}' unless defined(&stdc_bit_ceil);
    } else {
	eval 'sub stdc_bit_ceil {
	    my($x) = @_;
    	    eval q((( &__typeof ($x))  &stdc_bit_ceil_ull ($x)));
	}' unless defined(&stdc_bit_ceil);
    }
    if( &__GNUC_PREREQ (3, 4) ||  &__glibc_has_builtin ((defined(&__builtin_clzll) ? &__builtin_clzll : undef))) {
	eval 'sub stdc_bit_ceil_uc {
	    my($x) = @_;
    	    eval q((  &__bc8_inline ($x)));
	}' unless defined(&stdc_bit_ceil_uc);
	eval 'sub stdc_bit_ceil_us {
	    my($x) = @_;
    	    eval q((  &__bc16_inline ($x)));
	}' unless defined(&stdc_bit_ceil_us);
	eval 'sub stdc_bit_ceil_ui {
	    my($x) = @_;
    	    eval q((  &__bc32_inline ($x)));
	}' unless defined(&stdc_bit_ceil_ui);
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64) {
	    eval 'sub stdc_bit_ceil_ul {
	        my($x) = @_;
    		eval q((  &__bc64_inline ($x)));
	    }' unless defined(&stdc_bit_ceil_ul);
	} else {
	    eval 'sub stdc_bit_ceil_ul {
	        my($x) = @_;
    		eval q((  &__bc32_inline ($x)));
	    }' unless defined(&stdc_bit_ceil_ul);
	}
	eval 'sub stdc_bit_ceil_ull {
	    my($x) = @_;
    	    eval q((  &__bc64_inline ($x)));
	}' unless defined(&stdc_bit_ceil_ull);
    }
}
1;
